// This file is generated by kconfig_compiler from palapeli.kcfg.
// All changes you do to this file will be lost.
#ifndef SETTINGS_H
#define SETTINGS_H

#include <kconfigskeleton.h>
#include <kdebug.h>

class Settings : public KConfigSkeleton
{
  public:

    static Settings *self();
    ~Settings();

    /**
      Set Whether hardware acceleration should be used for the puzzle view.
    */
    static
    void setHardwareAccel( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "HardwareAccel" ) ))
        self()->mHardwareAccel = v;
    }

    /**
      Get Whether hardware acceleration should be used for the puzzle view.
    */
    static
    bool hardwareAccel()
    {
      return self()->mHardwareAccel;
    }

    /**
      Set Whether antialiasing should be used on the puzzle view.
    */
    static
    void setAntialiasing( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "Antialiasing" ) ))
        self()->mAntialiasing = v;
    }

    /**
      Get Whether antialiasing should be used on the puzzle view.
    */
    static
    bool antialiasing()
    {
      return self()->mAntialiasing;
    }

    /**
      Set Scene size (in multiples of the image size).
    */
    static
    void setSceneSizeFactor( double v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "SceneSizeFactor" ) ))
        self()->mSceneSizeFactor = v;
    }

    /**
      Get Scene size (in multiples of the image size).
    */
    static
    double sceneSizeFactor()
    {
      return self()->mSceneSizeFactor;
    }

    /**
      Set Quality of the minimap rendering (values: 0 = no translucent blocks, 1 = translucent blocks.)
    */
    static
    void setMinimapQuality( int v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "MinimapQuality" ) ))
        self()->mMinimapQuality = v;
    }

    /**
      Get Quality of the minimap rendering (values: 0 = no translucent blocks, 1 = translucent blocks.)
    */
    static
    int minimapQuality()
    {
      return self()->mMinimapQuality;
    }

    /**
      Set Precision of snapping (in percent of piece size).
    */
    static
    void setSnappingPrecision( int v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "SnappingPrecision" ) ))
        self()->mSnappingPrecision = v;
    }

    /**
      Get Precision of snapping (in percent of piece size).
    */
    static
    int snappingPrecision()
    {
      return self()->mSnappingPrecision;
    }

    /**
      Set Interval between automatic backups in seconds (or 0 if time-based backups are disabled).
    */
    static
    void setAutosaveTime( int v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "AutosaveTime" ) ))
        self()->mAutosaveTime = v;
    }

    /**
      Get Interval between automatic backups in seconds (or 0 if time-based backups are disabled).
    */
    static
    int autosaveTime()
    {
      return self()->mAutosaveTime;
    }

    /**
      Set Interval between automatic backups in moves (or 0 if action-based backups are disabled).
    */
    static
    void setAutosaveMoves( int v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "AutosaveMoves" ) ))
        self()->mAutosaveMoves = v;
    }

    /**
      Get Interval between automatic backups in moves (or 0 if action-based backups are disabled).
    */
    static
    int autosaveMoves()
    {
      return self()->mAutosaveMoves;
    }

  protected:
    Settings();
    friend class SettingsHelper;


    // Graphics
    bool mHardwareAccel;
    bool mAntialiasing;
    double mSceneSizeFactor;
    int mMinimapQuality;

    // Gameplay
    int mSnappingPrecision;

    // Autosave
    int mAutosaveTime;
    int mAutosaveMoves;

  private:
};

#endif

